/*

SharedIDVote library by ACWraith

This library provides a reusable datum which allows people to vote to have an action occur.
The catch is that only the vote from the first ID counts.  You can define the IDs.
(By default, this library uses IP addresses to prevent multiplayers from voting more than once.)

/////////////////////////////////////////////////////////////////////////////////////////////////
sidv_SharedIDVote

	sidv_ID(Voter)
		Returns the ID of Voter.  You'll want to overwrite this if you use different IDs.
		By default:
			If Voter voted, then the ID it used is returned.
			Next it tries to return the IP address of Voter if Voter is or currently has a client.
			It returns null otherwise, which is still a valid ID.

	sidv_AddVoter(Voter)
		Adds Voter as a legal voter and returns TRUE on success.

	sidv_CancelVote(Voter)
		Removes Voter's vote (if voted) and returns TRUE on success.

	sidv_CanVote(Voter)
		Returns wether or not Voter can vote.
		Voters must be registered.
		They must not have voted yet.
		They must be the first person with their ID to have voted.

	sidv_ClearVotes()
		Removes all votes.

	sidv_ClearVoters()
		Removes all voters and all votes.

	sidv_DidVote(Voter)
		Returns whether or not Voter voted.

	sidv_IDDidVote(ID)
		Returns whether or not someone with ID voted.

	sidv_IDsVoters()
		Returns a list of the IDs of all of the voters.
		Each ID is only listed once.

	sidv_IDsVoted()
		Returns a list of the IDs which voted.

	sidv_IsVoter(Candidate)
		Returns whether or not Candidate has been added as a voter.

	sidv_RemoveVoter(Voter)
		Makes Voter unable to vote.  If Voter voted, then the vote is removed.
		Returns TRUE on success.
		Note that this could cause the vote to pass.

	sidv_RequiredVotes()
		Returns the number of required votes.
		By default, this is the ceiling of half of the unique voter ID.
		If players are even, then another vote is added.
		This means that both players will have to vote in a two player game.

	sidv_Vote(Voter)
		Voter votes for the notion to succeed.
		Returns FALSE if Voter can not currently vote.
		If enough votes are met, then the result of the passing vote is returned.
		Otherwise, returns TRUE.

	sidv_VotePassed()
		The vote has passed.  You'll want to overwrite this to define what happened.
		By default, the votes are cleared.
		Returns TRUE.

	sidv_Voters()
		Returns the list of current voters.
*/