sidv_SharedIDVote/Demo
	//	This part is actually important.
	//	You have to overwrite the sidv_VotePassed() proc for it to do anything useful.
	sidv_VotePassed()
		world	<< "The vote passed!"
		..()

//	Create at least one sidv_SharedIDVote somewhere.
var/sidv_SharedIDVote/Demo/gVote	= new




//
//	The rest of this is just demo interface stuff that calls some of the library procs.
//	The runtime output is probably more valuable to learn from than the proc calls.
//

sidv_SharedIDVote/Demo
	//	If the default sidv_ID() proc was used then only clients and mobs could be voters.
	//	We don't want to gather a bunch of people with unique IPs just for this demo.
	//	Let's use a different ID.
	sidv_ID(Voter)
		return "[Voter]"

	//	Move along.  Just cleaning up the demo interface.
	sidv_ClearVotes()
		for(var/obj/DemoVoter/DV in src.sidv_Voters())	DV.suffix	= ""
		..()



//	We need some voters to test with.
obj/DemoVoter
	verb
		Cancel_Vote()
			set category	= null
			set desc		= "Remove this voter's vote."
			set src in world
			if ( gVote.sidv_CancelVote(src) )
				world		<< "The vote of [src] has been cancelled."
				src.suffix	= ""

		Remove_Voter()
			set category	= null
			set desc		= "Remove this voter from the system."
			set src in world
			world	<< "[src] is being removed.  Note that this could change the required votes."
			gVote.sidv_RemoveVoter(src)

		Vote()
			set category	= null
			set desc		= "Make this voter vote to pass."
			set src in world
			world	<< "[src] is trying to vote.  Note that each ID can only vote once."
			if ( gVote.sidv_Vote(src) )	src.suffix	= "VOTED"

client

	Stat()
		if ( statpanel("Voters") )
			stat("[gVote.sidv_RequiredVotes()] vote\s required.")
			stat("Right-click voter for options.")
			stat(gVote.sidv_Voters())

	verb
		Add_Voter(ID as text)
			set desc	= "(ID) Add a new voter called ID. Try the same ID multiple times."
			var/obj/DemoVoter/DV	= new
			DV.name					= ID
			if ( gVote.sidv_AddVoter(DV) )	world	<< "[DV] has been added as a voter."

		Clear_Votes()
			set desc	= "Remove all votes."
			if ( gVote.sidv_ClearVotes() )	world	<< "Votes have been cleared."

		Clear_Voters()
			set desc	= "Remove all voters."
			if ( gVote.sidv_ClearVoters() )
				world	<< "Voters have been cleared (along with their votes)."
